From d59167d27fd95c62c6e3d0c9196860beb6aeee65 Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Thu, 25 Jan 2018 17:07:50 -0500
Subject: [PATCH 13/14] FIXME: WIP on converting diagnostic_context to a class

---
 gcc/c-family/c-common.c     |   8 +-
 gcc/c-family/c-opts.c       |  10 +-
 gcc/c-family/c-pragma.c     |   4 +-
 gcc/c/c-decl.c              |   2 +-
 gcc/c/c-errors.c            |  10 +-
 gcc/c/c-objc-common.c       |   4 +-
 gcc/collect2.c              |   2 +-
 gcc/cp/error.c              |  68 +++----
 gcc/cp/typeck2.c            |   4 +-
 gcc/diagnostic-show-locus.c | 114 ++++++------
 gcc/diagnostic.c            | 421 ++++++++++++++++++++++----------------------
 gcc/diagnostic.h            | 186 +++++++++++--------
 gcc/fortran/cpp.c           |   8 +-
 gcc/fortran/error.c         |  99 ++++++-----
 gcc/fortran/options.c       |   4 +-
 gcc/gcc.c                   |   8 +-
 gcc/gcov-dump.c             |   2 +-
 gcc/gcov-tool.c             |   2 +-
 gcc/gcov.c                  |   2 +-
 gcc/input.c                 |  18 +-
 gcc/jit/dummy-frontend.c    |   4 +-
 gcc/jit/jit-playback.c      |   2 +-
 gcc/langhooks.c             |  28 +--
 gcc/lto-wrapper.c           |   2 +-
 gcc/opts-common.c           |   4 +-
 gcc/opts-global.c           |   2 +-
 gcc/opts.c                  |  26 +--
 gcc/rtl-error.c             |   2 +-
 gcc/selftest-diagnostic.c   |  10 +-
 gcc/substring-locations.c   |   2 +-
 gcc/toplev.c                |  36 ++--
 gcc/tree-diagnostic.c       |   6 +-
 32 files changed, 562 insertions(+), 538 deletions(-)

diff --git a/gcc/c-family/c-common.c b/gcc/c-family/c-common.c
index 858ed68..325d9aa 100644
--- a/gcc/c-family/c-common.c
+++ b/gcc/c-family/c-common.c
@@ -6088,7 +6088,7 @@ c_cpp_error (cpp_reader *pfile ATTRIBUTE_UNUSED, int level, int reason,
 {
   diagnostic_info diagnostic;
   diagnostic_t dlevel;
-  bool save_warn_system_headers = global_dc->dc_warn_system_headers;
+  bool save_warn_system_headers = global_dc->m_warn_system_headers;
   bool ret;
 
   switch (level)
@@ -6096,7 +6096,7 @@ c_cpp_error (cpp_reader *pfile ATTRIBUTE_UNUSED, int level, int reason,
     case CPP_DL_WARNING_SYSHDR:
       if (flag_no_output)
 	return false;
-      global_dc->dc_warn_system_headers = 1;
+      global_dc->m_warn_system_headers = 1;
       /* Fall through.  */
     case CPP_DL_WARNING:
       if (flag_no_output)
@@ -6129,9 +6129,9 @@ c_cpp_error (cpp_reader *pfile ATTRIBUTE_UNUSED, int level, int reason,
 				  richloc, dlevel);
   diagnostic_override_option_index (&diagnostic,
                                     c_option_controlling_cpp_error (reason));
-  ret = diagnostic_report_diagnostic (global_dc, &diagnostic);
+  ret = global_dc->report_diagnostic (&diagnostic);
   if (level == CPP_DL_WARNING_SYSHDR)
-    global_dc->dc_warn_system_headers = save_warn_system_headers;
+    global_dc->m_warn_system_headers = save_warn_system_headers;
   return ret;
 }
 
diff --git a/gcc/c-family/c-opts.c b/gcc/c-family/c-opts.c
index 3db01d4..cb92b95 100644
--- a/gcc/c-family/c-opts.c
+++ b/gcc/c-family/c-opts.c
@@ -170,8 +170,8 @@ c_diagnostic_finalizer (diagnostic_context *context,
   /* By default print macro expansion contexts in the diagnostic
      finalizer -- for tokens resulting from macro expansion.  */
   virt_loc_aware_diagnostic_finalizer (context, diagnostic);
-  pp_destroy_prefix (context->printer);
-  pp_flush (context->printer);
+  pp_destroy_prefix (context->m_printer);
+  pp_flush (context->m_printer);
 }
 
 /* Common default settings for diagnostics.  */
@@ -179,7 +179,7 @@ void
 c_common_diagnostics_set_defaults (diagnostic_context *context)
 {
   diagnostic_finalizer (context) = c_diagnostic_finalizer;
-  context->opt_permissive = OPT_fpermissive;
+  context->m_opt_permissive = OPT_fpermissive;
 }
 
 /* Whether options from all C-family languages should be accepted
@@ -255,7 +255,7 @@ c_common_init_options (unsigned int decoded_options_count,
   if (c_dialect_cxx ())
     set_std_cxx14 (/*ISO*/false);
 
-  global_dc->colorize_source_p = true;
+  global_dc->m_colorize_source_p = true;
 }
 
 /* Handle switch SCODE with argument ARG.  VALUE is true, unless no-
@@ -483,7 +483,7 @@ c_common_handle_option (size_t scode, const char *arg, int value,
 
     case OPT_fpermissive:
       flag_permissive = value;
-      global_dc->permissive = value;
+      global_dc->m_permissive = value;
       break;
 
     case OPT_fpreprocessed:
diff --git a/gcc/c-family/c-pragma.c b/gcc/c-family/c-pragma.c
index 84e4341..2592ca4 100644
--- a/gcc/c-family/c-pragma.c
+++ b/gcc/c-family/c-pragma.c
@@ -774,12 +774,12 @@ handle_pragma_diagnostic(cpp_reader *ARG_UNUSED(dummy))
     kind = DK_IGNORED;
   else if (strcmp (kind_string, "push") == 0)
     {
-      diagnostic_push_diagnostics (global_dc, input_location);
+      global_dc->push_diagnostics (input_location);
       return;
     }
   else if (strcmp (kind_string, "pop") == 0)
     {
-      diagnostic_pop_diagnostics (global_dc, input_location);
+      global_dc->pop_diagnostics (input_location);
       return;
     }
   else
diff --git a/gcc/c/c-decl.c b/gcc/c/c-decl.c
index f800464..3b171b9 100644
--- a/gcc/c/c-decl.c
+++ b/gcc/c/c-decl.c
@@ -5539,7 +5539,7 @@ warn_defaults_to (location_t location, int opt, const char *gmsgid, ...)
   diagnostic_set_info (&diagnostic, gmsgid, &ap, &richloc,
                        flag_isoc99 ? DK_PEDWARN : DK_WARNING);
   diagnostic.option_index = opt;
-  diagnostic_report_diagnostic (global_dc, &diagnostic);
+  global_dc->report_diagnostic (&diagnostic);
   va_end (ap);
 }
 
diff --git a/gcc/c/c-errors.c b/gcc/c/c-errors.c
index 2d50710..79fb5e5 100644
--- a/gcc/c/c-errors.c
+++ b/gcc/c/c-errors.c
@@ -48,7 +48,7 @@ pedwarn_c99 (location_t location, int opt, const char *gmsgid, ...)
 			   (pedantic && !flag_isoc11)
 			   ? DK_PEDWARN : DK_WARNING);
       diagnostic.option_index = OPT_Wc99_c11_compat;
-      warned = diagnostic_report_diagnostic (global_dc, &diagnostic);
+      warned = global_dc->report_diagnostic (&diagnostic);
     }
   /* -Wno-c99-c11-compat suppresses even the pedwarns.  */
   else if (warn_c99_c11_compat == 0)
@@ -58,7 +58,7 @@ pedwarn_c99 (location_t location, int opt, const char *gmsgid, ...)
     {
       diagnostic_set_info (&diagnostic, gmsgid, &ap, &richloc, DK_PEDWARN);
       diagnostic.option_index = opt;
-      warned = diagnostic_report_diagnostic (global_dc, &diagnostic);
+      warned = global_dc->report_diagnostic (&diagnostic);
     }
   va_end (ap);
   return warned;
@@ -92,7 +92,7 @@ pedwarn_c90 (location_t location, int opt, const char *gmsgid, ...)
 			       (pedantic && !flag_isoc99)
 			       ? DK_PEDWARN : DK_WARNING);
 	  diagnostic.option_index = opt;
-	  diagnostic_report_diagnostic (global_dc, &diagnostic);
+	  global_dc->report_diagnostic (&diagnostic);
 	  warned = true;
 	  goto out;
 	}
@@ -105,7 +105,7 @@ pedwarn_c90 (location_t location, int opt, const char *gmsgid, ...)
 			   (pedantic && !flag_isoc99)
 			   ? DK_PEDWARN : DK_WARNING);
       diagnostic.option_index = OPT_Wc90_c99_compat;
-      diagnostic_report_diagnostic (global_dc, &diagnostic);
+      global_dc->report_diagnostic (&diagnostic);
     }
   /* -Wno-c90-c99-compat suppresses the pedwarns.  */
   else if (warn_c90_c99_compat == 0)
@@ -115,7 +115,7 @@ pedwarn_c90 (location_t location, int opt, const char *gmsgid, ...)
     {
       diagnostic_set_info (&diagnostic, gmsgid, &ap, &richloc, DK_PEDWARN);
       diagnostic.option_index = opt;
-      diagnostic_report_diagnostic (global_dc, &diagnostic);
+      global_dc->report_diagnostic (&diagnostic);
       warned = true;
     }
 out:
diff --git a/gcc/c/c-objc-common.c b/gcc/c/c-objc-common.c
index a841bc1..43d361b 100644
--- a/gcc/c/c-objc-common.c
+++ b/gcc/c/c-objc-common.c
@@ -217,9 +217,9 @@ has_c_linkage (const_tree decl ATTRIBUTE_UNUSED)
 void
 c_initialize_diagnostics (diagnostic_context *context)
 {
-  pretty_printer *base = context->printer;
+  pretty_printer *base = context->m_printer;
   c_pretty_printer *pp = XNEW (c_pretty_printer);
-  context->printer = new (pp) c_pretty_printer ();
+  context->m_printer = new (pp) c_pretty_printer ();
 
   /* It is safe to free this object because it was previously XNEW()'d.  */
   base->~pretty_printer ();
diff --git a/gcc/collect2.c b/gcc/collect2.c
index f26bc59..1859c57 100644
--- a/gcc/collect2.c
+++ b/gcc/collect2.c
@@ -960,7 +960,7 @@ main (int argc, char **argv)
 
   gcc_init_libintl ();
 
-  diagnostic_initialize (global_dc, 0);
+  global_dc->initialize (0);
 
   if (atexit (collect_atexit) != 0)
     fatal_error (input_location, "atexit failed");
diff --git a/gcc/cp/error.c b/gcc/cp/error.c
index cb1dcf3..d953a08 100644
--- a/gcc/cp/error.c
+++ b/gcc/cp/error.c
@@ -154,9 +154,9 @@ class cxx_format_postprocessor : public format_postprocessor
 void
 cxx_initialize_diagnostics (diagnostic_context *context)
 {
-  pretty_printer *base = context->printer;
+  pretty_printer *base = context->m_printer;
   cxx_pretty_printer *pp = XNEW (cxx_pretty_printer);
-  context->printer = new (pp) cxx_pretty_printer ();
+  context->m_printer = new (pp) cxx_pretty_printer ();
 
   /* It is safe to free this object because it was previously XNEW()'d.  */
   base->~pretty_printer ();
@@ -3286,7 +3286,7 @@ cxx_print_error_function (diagnostic_context *context, const char *file,
 			  diagnostic_info *diagnostic)
 {
   lhd_print_error_function (context, file, diagnostic);
-  pp_set_prefix (context->printer, file);
+  pp_set_prefix (context->m_printer, file);
   maybe_print_instantiation_context (context);
 }
 
@@ -3294,11 +3294,11 @@ static void
 cp_diagnostic_starter (diagnostic_context *context,
 		       diagnostic_info *diagnostic)
 {
-  diagnostic_report_current_module (context, diagnostic_location (diagnostic));
+  context->report_current_module (diagnostic_location (diagnostic));
   cp_print_error_function (context, diagnostic);
   maybe_print_instantiation_context (context);
   maybe_print_constexpr_context (context);
-  pp_set_prefix (context->printer, diagnostic_build_prefix (context,
+  pp_set_prefix (context->m_printer, diagnostic_build_prefix (context,
 								 diagnostic));
 }
 
@@ -3314,16 +3314,16 @@ cp_print_error_function (diagnostic_context *context,
     return;
   if (diagnostic_last_function_changed (context, diagnostic))
     {
-      const char *old_prefix = context->printer->prefix;
+      const char *old_prefix = context->m_printer->prefix;
       const char *file = LOCATION_FILE (diagnostic_location (diagnostic));
       tree abstract_origin = diagnostic_abstract_origin (diagnostic);
       char *new_prefix = (file && abstract_origin == NULL)
 			 ? file_name_as_prefix (context, file) : NULL;
 
-      pp_set_prefix (context->printer, new_prefix);
+      pp_set_prefix (context->m_printer, new_prefix);
 
       if (current_function_decl == NULL)
-	pp_string (context->printer, _("At global scope:"));
+	pp_string (context->m_printer, _("At global scope:"));
       else
 	{
 	  tree fndecl, ao;
@@ -3341,7 +3341,7 @@ cp_print_error_function (diagnostic_context *context,
 	  else
 	    fndecl = current_function_decl;
 
-	  pp_printf (context->printer, function_category (fndecl),
+	  pp_printf (context->m_printer, function_category (fndecl),
 		     cxx_printable_name_translate (fndecl, 2));
 
 	  while (abstract_origin)
@@ -3386,34 +3386,34 @@ cp_print_error_function (diagnostic_context *context,
 	      if (fndecl)
 		{
 		  expanded_location s = expand_location (*locus);
-		  pp_character (context->printer, ',');
-		  pp_newline (context->printer);
+		  pp_character (context->m_printer, ',');
+		  pp_newline (context->m_printer);
 		  if (s.file != NULL)
 		    {
-		      if (context->show_column && s.column != 0)
-			pp_printf (context->printer,
+		      if (context->m_show_column && s.column != 0)
+			pp_printf (context->m_printer,
 				   _("    inlined from %qs at %r%s:%d:%d%R"),
 				   cxx_printable_name_translate (fndecl, 2),
 				   "locus", s.file, s.line, s.column);
 		      else
-			pp_printf (context->printer,
+			pp_printf (context->m_printer,
 				   _("    inlined from %qs at %r%s:%d%R"),
 				   cxx_printable_name_translate (fndecl, 2),
 				   "locus", s.file, s.line);
 
 		    }
 		  else
-		    pp_printf (context->printer, _("    inlined from %qs"),
+		    pp_printf (context->m_printer, _("    inlined from %qs"),
 			       cxx_printable_name_translate (fndecl, 2));
 		}
 	    }
-	  pp_character (context->printer, ':');
+	  pp_character (context->m_printer, ':');
 	}
-      pp_newline (context->printer);
+      pp_newline (context->m_printer);
 
       diagnostic_set_last_function (context, diagnostic);
-      pp_destroy_prefix (context->printer);
-      context->printer->prefix = old_prefix;
+      pp_destroy_prefix (context->m_printer);
+      context->m_printer->prefix = old_prefix;
     }
 }
 
@@ -3455,7 +3455,7 @@ print_instantiation_full_context (diagnostic_context *context)
 
   if (p)
     {
-      pp_verbatim (context->printer,
+      pp_verbatim (context->m_printer,
 		   TREE_CODE (p->decl) == TREE_LIST
 		   ? _("%s: In substitution of %qS:\n")
 		   : _("%s: In instantiation of %q#D:\n"),
@@ -3482,23 +3482,23 @@ print_instantiation_partial_context_line (diagnostic_context *context,
 
   expanded_location xloc = expand_location (loc);
 
-  if (context->show_column)
-    pp_verbatim (context->printer, _("%r%s:%d:%d:%R   "),
+  if (context->m_show_column)
+    pp_verbatim (context->m_printer, _("%r%s:%d:%d:%R   "),
 		 "locus", xloc.file, xloc.line, xloc.column);
   else
-    pp_verbatim (context->printer, _("%r%s:%d:%R   "),
+    pp_verbatim (context->m_printer, _("%r%s:%d:%R   "),
 		 "locus", xloc.file, xloc.line);
 
   if (t != NULL)
     {
       if (TREE_CODE (t->decl) == TREE_LIST)
-	pp_verbatim (context->printer,
+	pp_verbatim (context->m_printer,
 		     recursive_p
 		     ? _("recursively required by substitution of %qS\n")
 		     : _("required by substitution of %qS\n"),
 		     t->decl);
       else
-	pp_verbatim (context->printer,
+	pp_verbatim (context->m_printer,
 		     recursive_p
 		     ? _("recursively required from %q#D\n")
 		     : _("required from %q#D\n"),
@@ -3506,7 +3506,7 @@ print_instantiation_partial_context_line (diagnostic_context *context,
     }
   else
     {
-      pp_verbatim (context->printer,
+      pp_verbatim (context->m_printer,
 		   recursive_p
 		   ? _("recursively required from here\n")
 		   : _("required from here\n"));
@@ -3559,14 +3559,14 @@ print_instantiation_partial_context (diagnostic_context *context,
 	{
 	  expanded_location xloc;
 	  xloc = expand_location (loc);
-	  if (context->show_column)
-	    pp_verbatim (context->printer,
+	  if (context->m_show_column)
+	    pp_verbatim (context->m_printer,
 			 _("%r%s:%d:%d:%R   [ skipping %d instantiation "
 			   "contexts, use -ftemplate-backtrace-limit=0 to "
 			   "disable ]\n"),
 			 "locus", xloc.file, xloc.line, xloc.column, skip);
 	  else
-	    pp_verbatim (context->printer,
+	    pp_verbatim (context->m_printer,
 			 _("%r%s:%d:%R   [ skipping %d instantiation "
 			   "contexts, use -ftemplate-backtrace-limit=0 to "
 			   "disable ]\n"),
@@ -3619,15 +3619,15 @@ maybe_print_constexpr_context (diagnostic_context *context)
     {
       expanded_location xloc = expand_location (EXPR_LOCATION (t));
       const char *s = expr_as_string (t, 0);
-      if (context->show_column)
-	pp_verbatim (context->printer,
+      if (context->m_show_column)
+	pp_verbatim (context->m_printer,
 		     _("%r%s:%d:%d:%R   in %<constexpr%> expansion of %qs"),
 		     "locus", xloc.file, xloc.line, xloc.column, s);
       else
-	pp_verbatim (context->printer,
+	pp_verbatim (context->m_printer,
 		     _("%r%s:%d:%R   in %<constexpr%> expansion of %qs"),
 		     "locus", xloc.file, xloc.line, s);
-      pp_newline (context->printer);
+      pp_newline (context->m_printer);
     }
 }
 
@@ -4237,7 +4237,7 @@ pedwarn_cxx98 (location_t location, int opt, const char *gmsgid, ...)
   diagnostic_set_info (&diagnostic, gmsgid, &ap, &richloc,
 		       (cxx_dialect == cxx98) ? DK_PEDWARN : DK_WARNING);
   diagnostic.option_index = opt;
-  ret = diagnostic_report_diagnostic (global_dc, &diagnostic);
+  ret = global_dc->report_diagnostic (&diagnostic);
   va_end (ap);
   return ret;
 }
diff --git a/gcc/cp/typeck2.c b/gcc/cp/typeck2.c
index 8d93325..7796505 100644
--- a/gcc/cp/typeck2.c
+++ b/gcc/cp/typeck2.c
@@ -977,13 +977,13 @@ check_narrowing (tree type, tree init, tsubst_flags_t complain)
       else if (complain & tf_error)
 	{
 	  int savederrorcount = errorcount;
-	  global_dc->pedantic_errors = 1;
+	  global_dc->m_pedantic_errors = 1;
 	  pedwarn (loc, OPT_Wnarrowing,
 		   "narrowing conversion of %qE from %qH to %qI "
 		   "inside { }", init, ftype, type);
 	  if (errorcount == savederrorcount)
 	    ok = true;
-	  global_dc->pedantic_errors = flag_pedantic_errors;
+	  global_dc->m_pedantic_errors = flag_pedantic_errors;
 	}
     }
 
